!                                                                    !
!=========================>  ^DATESLD  <=============================!
!                                                                    !
!   Date Selection Processing - DATA                                 !
!                                                                    !
!   requires:   ^DATESLP     Date Selection Processing - Process     !
!                                                                    !
!====================================================================!
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!
!                                                                    !
!   these literals are maximum 40 characters (right justified):      !
!                         |---  0---|--- 10---|--- 20---|--- 30---|  !
!                         |123456789|123456789|123456789|123456789|  !
    SET ENTER.FROM.TXT$ = "            Enter From Date (MM/DD/YY):"  !
    SET ENTER.ONLY.TXT$ = "    Select Records for Date (MM/DD/YY):"  !
    SET ENTER.PROC.TXT$ = "              Processs Date (MM/DD/YY):"  !
    SET ENTER.TO.TXT$   = "            Enter To   Date (MM/DD/YY):"  !
!                                                                    !
    SET ECHO.FORMAT.ISO$        =  "*ISO"                            !
    SET ECHO.FORMAT.USA$        =  "*USA"                            !
!                                                                    !
    SET FIRST.FROM.DOW.3$       =  "   "                             !
    SET FIRST.FROM.ISO$         =  "0000-00-00"                      !
    SET FIRST.FROM.TEXT$        =  " *** FIRST ***"                  !
    SET FIRST.FROM.USA$         =  "00/00/0000"                      !
    SET INVALID.FROM.ISO$       =  "????-??-??"                      !
    SET INVALID.FROM.ISO0$      =  "????????"                        !
    SET INVALID.FROM.USA$       =  "??/??/????"                      !
    SET INVALID.FROM.USA0$      =  "????????"                        !
    SET INVALID.TO.ISO$         =  "????-??-??"                      !
    SET INVALID.TO.ISO0$        =  "????????"                        !
    SET INVALID.TO.USA$         =  "??/??/????"                      !
    SET INVALID.TO.USA0$        =  "????????"                        !
    SET LAST.TO.DOW.3$          =  "   "                             !
    SET LAST.TO.ISO$            =  "9999-99-99"                      !
    SET LAST.TO.TEXT$           =  " *** LAST ***"                   !
    SET LAST.TO.USA$            =  "99/99/9999"                      !
    SET DOW.3.LIT$              =  "  MonTueWedThuFriSatSun"         !
    SET DOW.3.UCASE$            =  "  MONTUEWEDTHUFRISATSUN"         !
    SET MON.3.LIT$      =  "  JanFebMarAprMayJunJulAugSepOctNovDec"  !
    SET MON.3.UCASE$    =  "  JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC"  !
!                                                                    !
!   if the Year is within these limits below, all leap years         !
!      can be determined by the folowing test:                       !
!      "IF FROM.TO.YY MOD 4 EQ 0"                                    !
    SET LEAP.YEAR.MINIMUM       =  1901                              !
    SET LEAP.YEAR.MAXIMUM       =  2099                              !
!                                                                    !
    LENGTH   4      & LOCAL ECHO.FORMAT$                             !
!                                                                    !
    LENGTH   3      & LOCAL SELECT.MON.3$                            !
!                                                                    !
    LENGTH   3      & LOCAL SELECT.FROM.DOW.3$                       !
    LENGTH   4      & LOCAL SELECT.FROM.FULL.YEAR$    !CCYY          !
    LENGTH   8      & LOCAL DEFAULT.FROM.DATE.MDY$    !MM/DD/YY      !
    LENGTH   8      & LOCAL SELECT.FROM.DATE$                        !
    LENGTH  10      & LOCAL DEFAULT.FROM.DATE.ISO$    !CCYY-MM-DD    !
    LENGTH  10      & LOCAL DEFAULT.FROM.DATE.USA$    !MM/DD/CCYY    !
    LENGTH  10      & LOCAL SELECT.FROM.DATE.ISO$     !CCYY-MM-DD    !
    LENGTH  10      & LOCAL SELECT.FROM.DATE.USA$     !MM/DD/CCYY    !
    LENGTH  16      & LOCAL SELECT.FROM.ECHO.ISO$     !CCYY-MM-DD    !
    LENGTH  16      & LOCAL SELECT.FROM.ECHO.USA$     !MM/DD/CCYY    !
    LENGTH  20      & LOCAL SELECT.FROM.ECHO$                        !
!                                                                    !
    LENGTH   3      & LOCAL SELECT.TO.DOW.3$                         !
    LENGTH   4      & LOCAL SELECT.TO.FULL.YEAR$      !CCYY          !
    LENGTH   8      & LOCAL DEFAULT.TO.DATE.MDY$      !MM/DD/YY      !
    LENGTH   8      & LOCAL SELECT.TO.DATE$                          !
    LENGTH  10      & LOCAL DEFAULT.TO.DATE.ISO$      !CCYY-MM-DD    !
    LENGTH  10      & LOCAL DEFAULT.TO.DATE.USA$      !MM/DD/CCYY    !
    LENGTH  10      & LOCAL SELECT.TO.DATE.ISO$       !CCYY-MM-DD    !
    LENGTH  10      & LOCAL SELECT.TO.DATE.USA$       !MM/DD/CCYY    !
    LENGTH  16      & LOCAL SELECT.TO.ECHO.ISO$       !CCYY-MM-DD    !
    LENGTH  16      & LOCAL SELECT.TO.ECHO.USA$       !MM/DD/CCYY    !
    LENGTH  20      & LOCAL SELECT.TO.ECHO$                          !
!                                                                    !
    LENGTH   1.0    & LOCAL FROM.TO.DATE.ERROR        !1=ERROR       !
    LENGTH   1      & LOCAL FROM.TO.DATE.ERROR$       !"Y"/"N"       !
    LENGTH   1      & LOCAL FROM.TO.DD.ERROR$         !"Y"/"N"       !
    LENGTH   1      & LOCAL FROM.TO.MM.ERROR$         !"Y"/"N"       !
    LENGTH   1      & LOCAL FROM.TO.MONTH.ERROR$      !"Y"/"N"       !
    LENGTH   1      & LOCAL FROM.TO.YEAR.ERROR$       !"Y"/"N"       !
    LENGTH   2      & LOCAL FROM.TO.DD$                              !
    LENGTH   2      & LOCAL FROM.TO.LAST.DD$                         !
    LENGTH   2      & LOCAL FROM.TO.MM$                              !
    LENGTH   2      & LOCAL FROM.TO.YY$                              !
    LENGTH   2.0    & LOCAL FROM.TO.DD                               !
    LENGTH   2.0    & LOCAL FROM.TO.LAST.DD                          !
    LENGTH   2.0    & LOCAL FROM.TO.MM                               !
    LENGTH   2.0    & LOCAL FROM.TO.YY                               !
    LENGTH   3      & LOCAL FROM.TO.DOW.3$                           !
    LENGTH   3.0    & LOCAL FROM.TO.DOW.IX                           !
    LENGTH   3      & LOCAL FROM.TO.MONTH$                           !
    LENGTH   3.0    & LOCAL FROM.TO.MONTH.LEN                        !
    LENGTH   3.0    & LOCAL FROM.TO.MONTH.POS                        !
    LENGTH   3.0    & LOCAL FROM.TO.MONTH.POS.CHECK                  !
    LENGTH   4      & LOCAL FROM.TO.CCYY$                            !
    LENGTH   4      & LOCAL FROM.TO.MM.WORK$                         !
    LENGTH   4.0    & LOCAL FROM.TO.CCYY                             !
    LENGTH   6      & LOCAL FROM.TO.DATE$                            !
    LENGTH   6      & LOCAL FROM.TO.DATE.MDY0$        !MMDDYY        !
    LENGTH   6      & LOCAL FROM.TO.DATE.YMD0$        !YYMMDD        !
    LENGTH   6.0    & LOCAL FROM.TO.DATE.SERIAL                      !
    LENGTH   6.0    & LOCAL FROM.TO.MOD.IX                           !
    LENGTH   8      & LOCAL FROM.TO.DATE.ISO0$        !CCYYMMDD      !
    LENGTH   8      & LOCAL FROM.TO.DATE.MDY$         !MM/DD/YY      !
    LENGTH   8      & LOCAL FROM.TO.DATE.USA0$        !MMDDCCYY      !
    LENGTH   8      & LOCAL FROM.TO.DATE.YMD$         !YY-MM-DD      !
    LENGTH  10      & LOCAL FROM.TO.DATE.ISO$         !CCYY-MM-DD    !
    LENGTH  10      & LOCAL FROM.TO.DATE.USA$         !MM/DD/CCYY    !

                                                                     !
ENTER.FROM.FMT: FORMAT_                                              !
    (sb);ENTER.FROM.TXT$,       @( 0,ROW.ENTER.FROM);__              !
    (TM),                       @(40,ROW.ENTER.FROM);_               !
    (SF);(MC);SELECT.FROM.DATE$,@(41,ROW.ENTER.FROM);(TM);(RC)       !
ENTER.FROM.ECHO.FMT: FORMAT_                                         !
    (SB);     SELECT.FROM.ECHO$,@(41,ROW.ENTER.FROM.ECHO)            !
ENTER.ONLY.FMT: FORMAT_                                              !
    (sb);ENTER.ONLY.TXT$,       @( 0,ROW.ENTER.FROM);__              !
    (TM),                       @(40,ROW.ENTER.FROM);_               !
    (SF);(MC);SELECT.FROM.DATE$,@(41,ROW.ENTER.FROM);(TM);(RC)       !
ENTER.PROC.FMT: FORMAT_                                              !
    (sb);ENTER.PROC.TXT$,       @( 0,ROW.ENTER.FROM);__              !
    (TM),                       @(40,ROW.ENTER.FROM);_               !
    (SF);(MC);SELECT.FROM.DATE$,@(41,ROW.ENTER.FROM);(TM);(RC)       !
ENTER.TO.FMT: FORMAT_                                                !
    (sb);ENTER.TO.TXT$,         @( 0,ROW.ENTER.TO);__                !
    (TM),                       @(40,ROW.ENTER.TO);_                 !
    (SF);(MC);SELECT.TO.DATE$,  @(41,ROW.ENTER.TO);(TM);(RC)         !
ENTER.TO.ECHO.FMT: FORMAT_                                           !
    (SB);     SELECT.TO.ECHO$,  @(41,ROW.ENTER.TO.ECHO)              !
!                                                                    !
!====================================================================!
