!                                                                    !
!=========================>  ^DATESLP  <=============================!
!                                                                    !
!   Date Selection Processing - Process                              !
!                                                                    !
!   requires:   ^DATESLD     Date Selection Processing - DATA        !
!                                                                    !
!====================================================================!
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!
!==========================
CVT.FROM.DATE.TO.ECHO.DATE:
!==========================
    SELECT.FROM.ECHO.ISO$ = SELECT.FROM.DATE.ISO$
    GOSUB CVT.FROM.TO.MDY.TO.USA
    SELECT.FROM.ECHO.USA$ = SELECT.FROM.DATE.USA$
    RETURN

!=======================
CVT.FROM.TO.ISO0.TO.ISO:
!=======================
    FROM.TO.DATE.ISO$ = SUB(FROM.TO.DATE.ISO0$,1,4) + "-" +_
                        SUB(FROM.TO.DATE.ISO0$,5,2) + "-" +_
                        SUB(FROM.TO.DATE.ISO0$,7,2)
!
    RETURN
!======================
CVT.FROM.TO.ISO.TO.USA:
!======================
    FROM.TO.DATE.USA$ = SUB(FROM.TO.DATE.ISO$,6,2) + "/" +_
                        SUB(FROM.TO.DATE.ISO$,9,2) + "/" +_
                        SUB(FROM.TO.DATE.ISO$,1,4)
!
    RETURN
!=======================
CVT.FROM.TO.ISO.TO.ISO0:
!=======================
    FROM.TO.DATE.ISO0$ = SUB(FROM.TO.DATE.ISO$,1,4) +_
                         SUB(FROM.TO.DATE.ISO$,6,2) +_
                         SUB(FROM.TO.DATE.ISO$,9,2)
!
    RETURN
!======================
CVT.FROM.TO.MDY.TO.ISO:
!======================
    FROM.TO.DATE.SERIAL  = DATE2NUM(FROM.TO.DATE.MDY$,0)
    SELECT CASE FROM.TO.DATE.SERIAL
        CASE -1
            FROM.TO.DATE.ISO0$  = INVALID.FROM.ISO0$
            FROM.TO.DATE.ERROR$ = Y.ANS$
        CASE ELSE
            FROM.TO.DATE.ISO0$  = NUM2DATE(FROM.TO.DATE.SERIAL,2)
            FROM.TO.DATE.ERROR$ = N.ANS$
    ENDSELECT
    GOSUB CVT.FROM.TO.ISO0.TO.ISO
!
    RETURN
!=======================
CVT.FROM.TO.MDY0.TO.ISO:
!=======================
    GOSUB CVT.FROM.TO.MDY0.TO.MDY
    GOSUB CVT.FROM.TO.MDY.TO.ISO
!
    RETURN
!=======================
CVT.FROM.TO.MDY0.TO.MDY:
!=======================
    FROM.TO.DATE.MDY$ = SUB(FROM.TO.DATE.MDY0$,1,2) + "/" +_
                        SUB(FROM.TO.DATE.MDY0$,3,2) + "/" +_
                        SUB(FROM.TO.DATE.MDY0$,5,2)
!
    RETURN
!======================
CVT.FROM.TO.MDY.TO.USA:
!======================
    FROM.TO.DATE.SERIAL  = DATE2NUM(FROM.TO.DATE.MDY$,0)
    FROM.TO.DATE.USA0$   = NUM2DATE(FROM.TO.DATE.SERIAL,0)
    GOSUB CVT.FROM.TO.USA0.TO.USA
!
    RETURN
!=======================
CVT.FROM.TO.USA0.TO.USA:
!=======================
    FROM.TO.DATE.USA$ = SUB(FROM.TO.DATE.USA0$,1,2) + "/" +_
                        SUB(FROM.TO.DATE.USA0$,3,2) + "/" +_
                        SUB(FROM.TO.DATE.USA0$,5,4)
!
    RETURN
!======================
CVT.FROM.TO.USA.TO.ISO:
!======================
    FROM.TO.DATE.ISO$ = SUB(FROM.TO.DATE.USA$,7,4) + "-" +_
                        SUB(FROM.TO.DATE.USA$,1,2) + "-" +_
                        SUB(FROM.TO.DATE.USA$,4,2)
!
    RETURN
!=======================
CVT.FROM.TO.USA.TO.USA0:
!=======================
    FROM.TO.DATE.USA0$ = SUB(FROM.TO.DATE.ISO0$,1,4) +_
                         SUB(FROM.TO.DATE.ISO0$,6,2) +_
                         SUB(FROM.TO.DATE.ISO0$,9,2)
!
    RETURN
!========================
CVT.TO.DATE.TO.ECHO.DATE:
!========================
    SELECT.TO.ECHO.ISO$ = SELECT.TO.DATE.ISO$
    GOSUB CVT.FROM.TO.MDY.TO.USA
    SELECT.TO.ECHO.USA$ = SELECT.TO.DATE.USA$
    RETURN
!===========================
DETERMINE.LAST.DAY.OF.MONTH:
!===========================
!	Because all dates will be from 1901..2099 we only divide by 4
	IF (275 * FROM.TO.MM) MOD 9 GT 3 THEN
		FROM.TO.LAST.DD = 31
	ELSE
		IF FROM.TO.MM GT 2 THEN
			FROM.TO.LAST.DD = 30
		ELSE
			IF FROM.TO.YY MOD 4 EQ 0 THEN
				FROM.TO.LAST.DD = 29
			ELSE
				FROM.TO.LAST.DD = 28
			ENDIF
		ENDIF
	ENDIF
	FROM.TO.LAST.DD$ = STRIP(STR(FROM.TO.LAST.DD))
	RETURN
!=======================
DETERMINE.MM.FROM.MONTH:
!=======================
    FROM.TO.MONTH$          = UCASE(FROM.TO.MONTH$)
    FROM.TO.MONTH.POS       = POS(FROM.TO.MONTH$,MON.3.UCASE$)
    IF FROM.TO.MONTH.POS EQ 0 THEN
       FROM.TO.MONTH.ERROR$ = Y.ANS$
       RETURN
    ENDIF
! there are 2 blanks pre-pended to the list of months
! therefore, JAN is in position 3..5,  DEC is in position 36..39
! so... dividing    by 3 will give the month number
! and.. multiplying by 3 should give back the original position
    FROM.TO.MONTH.POS.CHECK = FROM.TO.MONTH.POS / 3
    FROM.TO.MONTH.POS.CHECK = FROM.TO.MONTH.POS.CHECK * 3
    IF FROM.TO.MONTH.POS.CHECK NE FROM.TO.MONTH.POS THEN
       FROM.TO.MONTH.ERROR$ = Y.ANS$
       RETURN
    ENDIF
    FROM.TO.MONTH.ERROR$    = N.ANS$
    FROM.TO.MM              = FROM.TO.MONTH.POS / 3
    FROM.TO.MM.WORK$        = "00" + STRIP(STR(FROM.TO.MM))
    FROM.TO.MM$             = RSUB(FROM.TO.MM.WORK$,1,2)    !note: RSUB

    RETURN
!==============
ECHO.FROM.DATE:
!==============
!
    SELECT CASE ECHO.FORMAT$
        CASE ECHO.FORMAT.ISO$
            SELECT.FROM.ECHO$ = SELECT.FROM.ECHO.ISO$
        CASE ECHO.FORMAT.USA$
            SELECT.FROM.ECHO$ = SELECT.FROM.ECHO.USA$
        CASE ELSE
            SELECT.FROM.ECHO$ = SELECT.FROM.ECHO.ISO$
    ENDSELECT
    SELECT.FROM.ECHO$	= SELECT.FROM.DOW.3$ + " " + SELECT.FROM.ECHO$
    PRINT(CONSOLE,ENTER.FROM.ECHO.FMT)
    RETURN
!============
ECHO.TO.DATE:
!============
!
    SELECT CASE ECHO.FORMAT$
        CASE ECHO.FORMAT.ISO$
            SELECT.TO.ECHO$ = SELECT.TO.ECHO.ISO$
        CASE ECHO.FORMAT.USA$
            SELECT.TO.ECHO$ = SELECT.TO.ECHO.USA$
        CASE ELSE
            SELECT.TO.ECHO$ = SELECT.TO.ECHO.ISO$
    ENDSELECT
    SELECT.TO.ECHO$	= SELECT.TO.DOW.3$ + " " + SELECT.TO.ECHO$
    PRINT(CONSOLE,ENTER.TO.ECHO.FMT)
!
    RETURN
!================
FORMAT.FROM.DATE:
!================
    FROM.TO.DATE.MDY$ = SELECT.FROM.DATE$
    GOSUB CVT.FROM.TO.MDY.TO.ISO
!   if they originally supplied CCYY, make sure we give it back    
    IF SELECT.FROM.FULL.YEAR$ NE "" THEN 
       MOVE(SELECT.FROM.FULL.YEAR$,FROM.TO.DATE.ISO$,1,4)
    ENDIF
    GOSUB FORMAT.FROM.TO.DOW
    SELECT.FROM.DOW.3$    = FROM.TO.DOW.3$
    SELECT.FROM.DATE.ISO$ = FROM.TO.DATE.ISO$
    GOSUB CVT.FROM.DATE.TO.ECHO.DATE
!
	RETURN

!==================
FORMAT.FROM.TO.DOW:
!==================
	FROM.TO.MOD.IX 	= (FROM.TO.DATE.SERIAL + 2) MOD 7
	FROM.TO.MOD.IX	=  FROM.TO.MOD.IX + 1
	FROM.TO.DOW.IX  =  FROM.TO.MOD.IX * 3
	FROM.TO.DOW.3$  = SUB(DOW.3.LIT$,FROM.TO.DOW.IX,3)
!
	RETURN
!==============
FORMAT.TO.DATE:
!==============
    FROM.TO.DATE.MDY$ = SELECT.TO.DATE$
    GOSUB CVT.FROM.TO.MDY.TO.ISO
    IF SELECT.TO.FULL.YEAR$ NE "" THEN 
       MOVE(SELECT.TO.FULL.YEAR$,FROM.TO.DATE.ISO$,1,4)
    ENDIF    
    GOSUB FORMAT.FROM.TO.DOW
    SELECT.TO.DOW.3$    = FROM.TO.DOW.3$
    SELECT.TO.DATE.ISO$ = FROM.TO.DATE.ISO$
    GOSUB CVT.TO.DATE.TO.ECHO.DATE
!
    RETURN
!=============
GET.FROM.DATE:
!=============
    PRINT(CONSOLE,ENTER.FROM.FMT)
    INPUT(CONSOLE) SELECT.FROM.DATE$
    GOSUB PROC.FROM.DATE
!
    RETURN
!=========================
GET.FROM.DATE.AND.CONVERT:
!=========================
        DO
            FROM.TO.DATE.ERROR$ = Y.ANS$
            SELECT.FROM.DATE$ = DEFAULT.FROM.DATE.MDY$
            PRINT (CONSOLE,ENTER.FROM.FMT)
            INPUT (CONSOLE) SELECT.FROM.DATE$
            FROM.TO.DATE.MDY$ = SELECT.FROM.DATE$
            GOSUB CVT.FROM.TO.MDY.TO.ISO
            IF FROM.TO.DATE.ERROR$ EQ N.ANS$ THEN BREAK
        LOOP
        SELECT.FROM.DATE.ISO$  = FROM.TO.DATE.ISO$
        GOSUB CVT.FROM.DATE.TO.ECHO.DATE

        RETURN
!================
GET.PROCESS.DATE:
!================
    PRINT(CONSOLE,ENTER.PROC.FMT)
    INPUT(CONSOLE) SELECT.FROM.DATE$
    GOSUB PROC.FROM.DATE
    PRINT(CONSOLE,ENTER.FROM.ECHO.FMT)
!
    RETURN
!==================
GET.SELECTION.DATE:
!==================
    PRINT(CONSOLE,ENTER.ONLY.FMT)
    INPUT(CONSOLE) SELECT.FROM.DATE$
    GOSUB PROC.FROM.DATE
    PRINT(CONSOLE,ENTER.FROM.ECHO.FMT)
!
    RETURN
!===========
GET.TO.DATE:
!===========
    PRINT(CONSOLE,ENTER.TO.FMT)
    INPUT(CONSOLE) SELECT.TO.DATE$
    GOSUB PROC.TO.DATE
!
    RETURN
!=======================
GET.TO.DATE.AND.CONVERT:
!=======================
        DO
            FROM.TO.DATE.ERROR$ = Y.ANS$
            SELECT.TO.DATE$ = DEFAULT.TO.DATE.MDY$
            PRINT (CONSOLE,ENTER.TO.FMT)
            INPUT (CONSOLE) SELECT.TO.DATE$
            FROM.TO.DATE.MDY$ = SELECT.TO.DATE$
            GOSUB CVT.FROM.TO.MDY.TO.ISO
            IF FROM.TO.DATE.ERROR$ EQ N.ANS$ THEN BREAK
        LOOP
        SELECT.TO.DATE.ISO$  = FROM.TO.DATE.ISO$
        GOSUB CVT.TO.DATE.TO.ECHO.DATE

        RETURN
!======================
POPULATE.DEFAULT.DATES:
!======================
    FROM.TO.DATE.MDY0$ = DATE$
    GOSUB CVT.FROM.TO.MDY0.TO.MDY
    DEFAULT.FROM.DATE.MDY$ = FROM.TO.DATE.MDY$
    GOSUB CVT.FROM.TO.MDY.TO.ISO
    DEFAULT.FROM.DATE.ISO$ = FROM.TO.DATE.ISO$
    GOSUB CVT.FROM.TO.ISO.TO.USA
    DEFAULT.FROM.DATE.USA$ = FROM.TO.DATE.USA$
!
    DEFAULT.TO.DATE.MDY$ = DEFAULT.FROM.DATE.MDY$
    DEFAULT.TO.DATE.ISO$ = DEFAULT.FROM.DATE.ISO$
    DEFAULT.TO.DATE.USA$ = DEFAULT.FROM.DATE.USA$
!
    RETURN
!==============
PROC.FROM.DATE:
!==============
    SELECT.FROM.FULL.YEAR$ = ""
!	Special processing for a single month (MON/YY or MON/CCYY)
	IF SUB(SELECT.FROM.DATE$,4,1) EQ "/" THEN
		GOSUB PROC.FROM.MONTH
		RETURN
	ENDIF
!   Special processing if the operator just presses Enter (Tab/F10)
    IF LEN(STRIP(SELECT.FROM.DATE$)) EQ 0 THEN
        SELECT.FROM.DATE.ISO$ = FIRST.FROM.ISO$
        SELECT.FROM.ECHO.ISO$ = FIRST.FROM.TEXT$
        SELECT.FROM.ECHO.USA$ = FIRST.FROM.TEXT$
        SELECT.FROM.DOW.3$    = FIRST.FROM.DOW.3$
        RETURN
    ENDIF
!
	GOSUB FORMAT.FROM.DATE
!
    RETURN

!===============
PROC.FROM.MONTH:
!===============
	FROM.TO.MONTH.LEN = LEN(SELECT.FROM.DATE$)
	FROM.TO.MONTH$    = SUB(SELECT.FROM.DATE$,1,3)
    GOSUB DETERMINE.MM.FROM.MONTH
    SELECT CASE FROM.TO.MONTH.LEN
    	CASE 6	! MON/YY
    		FROM.TO.YY$            = SUB(SELECT.FROM.DATE$,5,2)
            SELECT.FROM.FULL.YEAR$ = ""
    	CASE 8	! MON/CCYY
    		FROM.TO.YY$            = SUB(SELECT.FROM.DATE$,7,2)
            SELECT.FROM.FULL.YEAR$ = SUB(SELECT.FROM.DATE$,5,4)
	ENDSELECT
	SELECT.FROM.DATE$ = FROM.TO.MM$ + "/01/" + FROM.TO.YY$
    PRINT(CONSOLE,ENTER.FROM.FMT)
	GOSUB FORMAT.FROM.DATE
	FROM.TO.YY = NUM(FROM.TO.YY$,FROM.TO.DATE.ERROR)
	GOSUB DETERMINE.LAST.DAY.OF.MONTH
	SELECT.TO.DATE$ = FROM.TO.MM$      + "/" + _
	                  FROM.TO.LAST.DD$ + "/" + FROM.TO.YY$
	GOSUB FORMAT.TO.DATE
!
	RETURN

!============
PROC.TO.DATE:
!============
    SELECT.TO.FULL.YEAR$ = ""
	IF SUB(SELECT.TO.DATE$,4,1) EQ "/" THEN
		GOSUB PROC.TO.MONTH
		RETURN
	ENDIF
!   Special processing if the operator just presses Enter (Tab/F10)
    IF LEN(STRIP(SELECT.TO.DATE$)) EQ 0 THEN
        SELECT.TO.DATE.ISO$ = LAST.TO.ISO$
        SELECT.TO.ECHO.ISO$ = LAST.TO.TEXT$
        SELECT.TO.ECHO.USA$ = LAST.TO.TEXT$
        SELECT.TO.DOW.3$    = LAST.TO.DOW.3$
        RETURN
    ENDIF
!
	GOSUB FORMAT.TO.DATE
!
	RETURN

!=============
PROC.TO.MONTH:
!=============
	FROM.TO.MONTH.LEN = LEN(SELECT.TO.DATE$)
	FROM.TO.MONTH$    = SUB(SELECT.TO.DATE$,1,3)
    GOSUB DETERMINE.MM.FROM.MONTH
    SELECT CASE FROM.TO.MONTH.LEN
    	CASE 6	! MON/YY
    		FROM.TO.YY$          = SUB(SELECT.TO.DATE$,5,2)
            SELECT.TO.FULL.YEAR$ = ""
    	CASE 8	! MON/CCYY
    		FROM.TO.YY$          = SUB(SELECT.TO.DATE$,7,2)
            SELECT.TO.FULL.YEAR$ = SUB(SELECT.TO.DATE$,5,4)
	ENDSELECT
	FROM.TO.YY = NUM(FROM.TO.YY$,FROM.TO.DATE.ERROR)
	GOSUB DETERMINE.LAST.DAY.OF.MONTH
	SELECT.TO.DATE$ = FROM.TO.MM$      + "/" + _
	                  FROM.TO.LAST.DD$ + "/" + FROM.TO.YY$
	GOSUB FORMAT.TO.DATE
    PRINT(CONSOLE,ENTER.TO.FMT)
!
	RETURN

!====================================================================!
