!=========================>  ^ELAPSP  <==============================!
!                                                                    !
!   Elapsed Time Processing - Processing                             !
!                                                                    !
!   requires:   ^ELAPSP       Elapsed Time Processing - Data         !
!                                                                    !
!====================================================================!
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!
!                                                                    !
!   The output of NUM2DATE with option 6 is:                         !
!                         |---  0---|--- 10---|--- 20---|--- 30---|  !
!                         |123456789|123456789|123456789|123456789|  !
!                          HH:MM:SS.mmm                              !
!                                                                    !
!====================================================================!
!=======================
COMPUTE.ELAPSED.SECONDS:
!=======================
        ELAPS.SECONDS     = (((ELAPS.HH  * 60) + _
                               ELAPS.MM) * 60) + _
                               ELAPS.SS

        RETURN
!====================
COMPUTE.ELAPSED.TIME:
!====================
        ELAPS.SECONDS = ELAPS.END.SECONDS - ELAPS.START.SECONDS
        IF  ELAPS.SECONDS LT 0 THEN
            ELAPS.SECONDS = ELAPS.SECONDS + 86400
        ENDIF
        ELAPS.SECONDS = ELAPS.SECONDS MOD 86400
        ELAPS.SS      = ELAPS.SECONDS MOD 60
        ELAPS.SECONDS = ELAPS.SECONDS  /  60
        ELAPS.MM      = ELAPS.SECONDS MOD 60
        ELAPS.SECONDS = ELAPS.SECONDS  /  60
        ELAPS.HH      = ELAPS.SECONDS MOD 24
        GOSUB CONVERT.HH.MM.SS.TO.STRINGS
        GOSUB EDIT.ELAPSED.TIME
        GOSUB EDIT.ELAPSED.TIME.MESSAGE
        GOSUB EDIT.ELAPSED.RUNTOT.MESSAGE
!
        RETURN
!===================
COMPUTE.END.SECONDS:
!===================
        ELAPS.END.TIME$         = SUB(ELAPS.END.TIME.WITH.MS$,1,8)
        ELAPS.HH$               = SUB(ELAPS.END.TIME$,1,2)
        ELAPS.MM$               = SUB(ELAPS.END.TIME$,4,2)
        ELAPS.SS$               = SUB(ELAPS.END.TIME$,7,2)
        GOSUB CONVERT.HH.MM.SS.TO.NUMBERS
        GOSUB COMPUTE.ELAPSED.SECONDS
        ELAPS.END.SECONDS       = ELAPS.SECONDS
!
        RETURN
!================
COMPUTE.HH.MM.SS:
!================
        ELAPS.HH.MM.SS = (((ELAPS.HH  * 100) + _
                            ELAPS.MM) * 100) + _
                            ELAPS.SS
!
        RETURN
!=====================
COMPUTE.START.SECONDS:
!=====================
        ELAPS.START.TIME$           = SUB(ELAPS.START.TIME.WITH.MS$,1,8)
        ELAPS.HH$                   = SUB(ELAPS.START.TIME$,1,2)
        ELAPS.MM$                   = SUB(ELAPS.START.TIME$,4,2)
        ELAPS.SS$                   = SUB(ELAPS.START.TIME$,7,2)
        GOSUB CONVERT.HH.MM.SS.TO.NUMBERS
        GOSUB COMPUTE.ELAPSED.SECONDS
        ELAPS.START.SECONDS         = ELAPS.SECONDS
!
        RETURN

!===========================
CONVERT.HH.MM.SS.TO.NUMBERS:
!===========================
        ELAPS.HH    = NUM(ELAPS.HH$,ELAPS.NUM.ERR)
        ELAPS.MM    = NUM(ELAPS.MM$,ELAPS.NUM.ERR)
        ELAPS.SS    = NUM(ELAPS.SS$,ELAPS.NUM.ERR)
!
        RETURN
!===========================
CONVERT.HH.MM.SS.TO.STRINGS:
!===========================
        ELAPS.WORK$ = STR(ELAPS.HH)
        ELAPS.WORK$ = "00" + STRIP(ELAPS.WORK$)
        ELAPS.HH$   = RSUB(ELAPS.WORK$,1,2)
        ELAPS.WORK$ = STR(ELAPS.MM)
        ELAPS.WORK$ = "00" + STRIP(ELAPS.WORK$)
        ELAPS.MM$   = RSUB(ELAPS.WORK$,1,2)
        ELAPS.WORK$ = STR(ELAPS.SS)
        ELAPS.WORK$ = "00" + STRIP(ELAPS.WORK$)
        ELAPS.SS$   = RSUB(ELAPS.WORK$,1,2)

!
        RETURN
!=============
EDIT.HH.MM.SS:
!=============
        ELAPS.HH.MM.SS$ = STR(ELAPS.HH.MM.SS)
!
        RETURN
!=================
EDIT.ELAPSED.TIME:
!=================
        ELAPS.TIME$   = ELAPS.HH$ + ":" + _
                        ELAPS.MM$ + ":" + _
                        ELAPS.SS$
!
        RETURN
!===========================
EDIT.ELAPSED.RUNTOT.MESSAGE:
!===========================
        ELAPS.RUNTOT.MESSAGE$ = SUB(ELAPS.START.TIME$,1,2) + _
                                SUB(ELAPS.START.TIME$,4,2) + _
                                SUB(ELAPS.START.TIME$,7,2) + _
                                "+" + _
                                SUB(ELAPS.TIME$,1,2) + _
								SUB(ELAPS.TIME$,4,2) + _
								SUB(ELAPS.TIME$,7,2) + _
								">" + _
							   	SUB(ELAPS.END.TIME$,1,2) + _
								SUB(ELAPS.END.TIME$,4,2) + _
								SUB(ELAPS.END.TIME$,7,2)
!
        RETURN
!=========================
EDIT.ELAPSED.TIME.MESSAGE:
!=========================
        ELAPS.TIME.MESSAGE$ = ELAPS.START.TIME$ + " + "  + _
                              ELAPS.TIME$       + " > " + _
                              ELAPS.END.TIME$
        RETURN
!================
ELAPSED.EPILOGUE:
!================
        GOSUB SAVE.END.TIME
        GOSUB COMPUTE.ELAPSED.TIME

        RETURN
!============================
ELAPSED.EPILOGUE.AND.DISPLAY:
!============================
        GOSUB ELAPSED.EPILOGUE
        GOSUB ELAPSED.EPILOGUE.DISPLAY

        RETURN
!================--------
ELAPSED.EPILOGUE.DISPLAY:
!========================
        MESS$ = ELAPS.TIME.MESSAGE$
        GOSUB PRINT.OPERATOR.MESS
        
        RETURN
!================
ELAPSED.PROLOGUE:
!================
        GOSUB SAVE.START.TIME
        RETURN
!=============
SAVE.END.TIME:
!=============
        ELAPS.END.TIME.WITH.MS$ = NUM2DATE(0,6)
        GOSUB COMPUTE.END.SECONDS
!
        RETURN

!===============
SAVE.START.TIME:
!===============
        ELAPS.START.TIME.WITH.MS$   = NUM2DATE(0,6)
        GOSUB COMPUTE.START.SECONDS
!
        RETURN
!                                                                    !
!====================================================================!