!                                                                    !
!=========================>  ^RUNTOT  <==============================!
.if DECPASS
!                                                                    !
!  File Format & Length Declaratives                                 !
!                                                                    !
!  File Name: RUNTOT           RUN TOTALS FILE                       !
!                                                                    !
!       Type: K    Record: 120    Key: 50    Image: N                !
!                                                                    !
!  #FILES File Name: RUNTOT                       Date: 12/01/2009   !
!                                                                    !
!   requires:   ^RUNTOT     RUNTOT file definition                   !
!                RUNTOT     LUN (Logical Unit Number) must be SET    !
!                           OUTPUT.PROGRAM.SPECIFIC.RUNTOT           !
!                PROGRAM.ID$                                         !
!                                                                    !
!	Note:        Description is actually truncated by 2 bytes        !
!                due to original miscalculation of lengths of:       !
!                RUNTOT.COUNT.DR and RUNTOT.COUNT.CR                 !
!                amended: 2010-04-28                                 !
!====================================================================!
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!
!                                                                    !
!--------------------------------------------------------------------!
    LENGTH    6.0   &   LOCAL   RUNTOT.DATE.TIME.SERIAL              !
    LENGTH    6.0   &   LOCAL   RUNTOT.SERIAL.DATE                   !
    LENGTH    8.8   &   LOCAL   RUNTOT.SERIAL.TIME.FRACTION          !
    LENGTH   14.8   &   LOCAL   RUNTOT.SERIAL.DATE.TIME              !
!                                                                    !
!   RUNTOT.DATE$    is the COMET System Variable DATE$               !
!   RUNTOT.DATE     is the COMET System Variable DATE                !
    LENGTH    6     &   LOCAL   RUNTOT.DATE$            !MMDDYY      !
    LENGTH    6.0   &   LOCAL   RUNTOT.DATE             !MMDDYY      !
!--------------------------------------------------------------------!
    LENGTH    4     &   LOCAL   RUNTOT.DATE.CCYY$                    !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.CCYYMMDD$   !CCYYMMDD    !
    LENGTH    2     &   LOCAL   RUNTOT.DATE.CC$                      !
    LENGTH    2     &   LOCAL   RUNTOT.DATE.YY$                      !
    LENGTH    2     &   LOCAL   RUNTOT.DATE.MM$                      !
    LENGTH    2     &   LOCAL   RUNTOT.DATE.DD$                      !
    LENGTH   12     &   LOCAL   RUNTOT.TIME.COMET$      !HH:MM:SS.DDD!
    LENGTH    8     &   LOCAL   RUNTOT.TIME.ISO$        !HH.MM.SS    !
!--------------------------------------------------------------------!
!   Work Area - Format Unspecified                                   !
    LENGTH   10     &   LOCAL   RUNTOT.DATE.TODAY.10$                !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.TODAY.8$                 !
    LENGTH    6     &   LOCAL   RUNTOT.DATE.TODAY.6$                 !
!--------------------------------------------------------------------!
!   Work Area - Edited                                               !
!   EUR => European                                                  !
!   ISO => International Standardisation Organisation                !
    LENGTH   10     &   LOCAL   RUNTOT.DATE.EUR$        !DD.MM.CCYY  !
    LENGTH   10     &   LOCAL   RUNTOT.DATE.ISO$        !CCYY-MM-DD  !
    LENGTH   10     &   LOCAL   RUNTOT.DATE.USA$        !MM/DD/CCYY  !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.DMY$        !DD.MM.YY    !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.MDY$        !MM/DD/YY    !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.YMD$        !YY-MM-DD    !
!--------------------------------------------------------------------!
!   WORK Area - UnEdited (Terminal Zero => "Zero Editing")           !
    LENGTH   10     &   LOCAL   RUNTOT.DATE.EUR0$       !DDMMCCYY    !
    LENGTH   10     &   LOCAL   RUNTOT.DATE.ISO0$       !CCYYMMDD    !
    LENGTH   10     &   LOCAL   RUNTOT.DATE.USA0$       !MMDDCCYY    !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.DMY0$       !DDMMYY      !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.MDY0$       !MMDDYY      !
    LENGTH    8     &   LOCAL   RUNTOT.DATE.YMD0$       !YYMMDD      !
!--------------------------------------------------------------------!
    LENGTH    3.0   &   LOCAL   IX.RUNTOT                            !
    LENGTH    3.0   &   LOCAL   IX.RUNTOT.MAX                        !
!--------------------------------------------------------------------!
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.1             !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.1.3           !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.2             !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.3             !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.4             !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.4.6           !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.5             !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.KEY.6             !
    LENGTH    3.0   &   LOCAL   CURRENT.LEN.RUNTOT.DESC              !
    SET RUNTOT.AMOUNT.IS.SMALL  =   9999.99999                       !
    SET RUNTOT.COUNT.IS.SMALL   =   9999                             !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.AMOUNT.DR.IS.SMALL$   !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.AMOUNT.DR.IS.ZERO$    !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.AMOUNT.CR.IS.SMALL$   !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.AMOUNT.CR.IS.ZERO$    !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.COUNT.DR.IS.SMALL$    !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.COUNT.DR.IS.ZERO$     !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.COUNT.CR.IS.SMALL$    !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.COUNT.CR.IS.ZERO$     !
!                                                                    !
    LENGTH    1     &   LOCAL   PRINT.RUNTOT.LINES.TO.SPOOL$         !
    LENGTH    1     &   LOCAL   WRITE.RUNTOT.RECORDS.TO.FILE$        !
!                                                                    !
    LENGTH    1     &   LOCAL   PRINT.RUNTOT.AMOUNTS.ONLY$           !
    LENGTH    1     &   LOCAL   PRINT.RUNTOT.COUNTS.ONLY$            !
!                                                                    !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$     !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.COUNTS.ARE.ZERO$      !
    LENGTH    1     &   LOCAL   CURRENT.RUNTOT.RECORD.IS.ZERO$       !
!                                                                    !
    LENGTH    1     &   LOCAL   PRINT.ZERO.RUNTOT.LINES.TO.SPOOL$    !
    LENGTH    1     &   LOCAL   WRITE.ZERO.RUNTOT.RECORDS.TO.FILE$   !
!--------------------------------------------------------------------!
    LENGTH   48     &   LOCAL   RUNTOT.KEY.1.6$                      !
    LENGTH   50     &   LOCAL   RUNTOT.KEY$                          !
    LENGTH    3.0   &   LOCAL   RUNTOT.WRITTEN                       !
    LENGTH    5     &   LOCAL   RUNTOT.WRITTEN$                      !
    SET LEN.RUNTOT.KEY.1=8                                           !
    SET LEN.RUNTOT.KEY.2=8                                           !
    SET LEN.RUNTOT.KEY.3=8                                           !
    SET LEN.RUNTOT.KEY.4=8                                           !
    SET LEN.RUNTOT.KEY.5=8                                           !
    SET LEN.RUNTOT.KEY.6=8                                           !
    SET LEN.RUNTOT.TYPE=2                                            !
!!! RUNTOT.DESC$ was defined as 20, but is actually truncated to 18  !
!!! SET LEN.RUNTOT.DESC=20                                           !
    SET LEN.RUNTOT.DESC=18                                           !
!                                                                    !
    LENGTH LEN.RUNTOT.KEY.1 &   LOCAL   RUNTOT.KEY.1$                !
    LENGTH LEN.RUNTOT.KEY.2 &   LOCAL   RUNTOT.KEY.2$                !
    LENGTH LEN.RUNTOT.KEY.3 &   LOCAL   RUNTOT.KEY.3$                !
    LENGTH LEN.RUNTOT.KEY.4 &   LOCAL   RUNTOT.KEY.4$                !
    LENGTH LEN.RUNTOT.KEY.5 &   LOCAL   RUNTOT.KEY.5$                !
    LENGTH LEN.RUNTOT.KEY.6 &   LOCAL   RUNTOT.KEY.6$                !
    LENGTH LEN.RUNTOT.TYPE  &   LOCAL   RUNTOT.TYPE$                 !
    LENGTH   15.5           &   LOCAL   RUNTOT.AMOUNT.DR             !
    LENGTH   15.5           &   LOCAL   RUNTOT.AMOUNT.CR             !
    LENGTH    7.0           &   LOCAL   RUNTOT.COUNT.DR              !
    LENGTH    7.0           &   LOCAL   RUNTOT.COUNT.CR              !
    LENGTH LEN.RUNTOT.DESC  &   LOCAL   RUNTOT.DESC$                 !
!                                                                    !
    LENGTH LEN.RUNTOT.KEY.1 &   LOCAL   SAVE.RUNTOT.KEY.1$           !
    LENGTH LEN.RUNTOT.KEY.2 &   LOCAL   SAVE.RUNTOT.KEY.2$           !
    LENGTH LEN.RUNTOT.KEY.3 &   LOCAL   SAVE.RUNTOT.KEY.3$           !
    LENGTH LEN.RUNTOT.KEY.4 &   LOCAL   SAVE.RUNTOT.KEY.4$           !
    LENGTH LEN.RUNTOT.KEY.5 &   LOCAL   SAVE.RUNTOT.KEY.5$           !
    LENGTH LEN.RUNTOT.KEY.6 &   LOCAL   SAVE.RUNTOT.KEY.6$           !
    LENGTH LEN.RUNTOT.TYPE  &   LOCAL   SAVE.RUNTOT.TYPE$            !
!====================================================================!
    SET     RECL.RUNTOT=120                                          !
    SET     KEYL.RUNTOT=50                                           !
!====================================================================!         !
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!         !
!                          Description            LENGTH  WIDTH  OFF !         !
!                          ------------------------------------------!         !
RUNTOT.FMT: FORMAT  _     !                                          !
    RUNTOT.KEY.1$;_       !Key#1 (Program Name)      8        8    0 !
    RUNTOT.KEY.2$;_       !Key#2 (CCYYMMDD)          8        8    8 !
    RUNTOT.KEY.3$;_       !Key#3 (HH:MM:SS)          8        8   16 !
    RUNTOT.KEY.4$;_       !Key#4                     8        8   24 !
    RUNTOT.KEY.5$;_       !Key#5                     8        8   32 !
    RUNTOT.KEY.6$;_       !Key#6                     8        8   40 !
    RUNTOT.TYPE$;_        !Type (## or ZZ)           2        2   48 !
    RUNTOT.AMOUNT.DR;_    !Amount (Debit )          15.5     17   50 !
    RUNTOT.AMOUNT.CR;_    !Amount (Credit)          15.5     17   67 !
    RUNTOT.COUNT.DR;_     !Count  (Debit )           7.0      9   84 !
    RUNTOT.COUNT.CR;_     !Count  (Credit)           7.0      9   93 !
    RUNTOT.DESC$          !Description              20       20  102 !
                          !                                      120 !
!====================================================================!
!--------------------------------------------------------------------!
!   RUNTOT Report Variables                                          !
!                                                                    !
    SET FORCE.RUNTOT.HEADER.PRINT=2 !minimum value for RUNTOT.LINE   !
    SET LINES.PER.RUNTOT.PAGE=55                                     !
    SET RUN.TOTALS.REPORT$="R U N     T O T A L S     R E P O R T"   !
    SET R.E.P.O.R.T$      ="R   E   P   O   R   T"                   !
    LENGTH  50      &   LOCAL   RUNTOT.HEADER.TEXT$                  !
!                                                                    !
    LENGTH   3.0    &   LOCAL   RUNTOT.LINE                          !
    LENGTH   3.0    &   LOCAL   RUNTOT.PAGE                          !
    LENGTH   7.0    &   LOCAL   NR.OF.RUNTOT.LINES                   !
    LENGTH   3.0    &   LOCAL   NR.OF.RUNTOT.PAGES                   !
    SET RUNTOT.DATE.TIME.LEN      =25                                !
    SET RUNTOT.DATE.TIME.LEN.LOCAL=37                                !
    SET RUNTOT.DATE.TIME.OPT.LOCAL=5                                 !
    LENGTH RUNTOT.DATE.TIME.LEN       & LOCAL RUNTOT.DATE.TIME$      !
    LENGTH RUNTOT.DATE.TIME.LEN.LOCAL & LOCAL RUNTOT.DATE.TIME.LOCAL$!
!                                                                    !
!   RUNTOT.HEADER.FMT: FORMAT (FF);__                                !
!       RUNTOT.DATE.CCYYMMDD$,@(0);_                                 !
!       "@@";_                                                       !
!       RUNTOT.TIME.ISO$,@(10);_                                     !
!       PROGRAM.ID$,@(25);_                                          !
!       "RUN TOTALS REPORT",@(40);_                                  !
!       "PAGE ",@(100);RUNTOT.PAGE;_                                 !
!       (LF)                                                         !
RUNTOT.HEADER.FMT: FORMAT (FF);__                                    !
    RUNTOT.DATE.TIME$ ,@(0);_                                        !
    PROGRAM.ID$,@(28);_                                              !
    RUNTOT.HEADER.TEXT$,@(40);_                                      !
    "PAGE ",@(100);RUNTOT.PAGE;_                                     !
    (LF)                                                             !
    SET RUNTOT.DETAIL.FMT.LINES=2                                    !
RUNTOT.DETAIL.FMT: FORMAT _                                          !
        RUNTOT.KEY.4$,@(00);_                                        !
        RUNTOT.KEY.5$,@(10);_                                        !
        RUNTOT.KEY.6$,@(20);_                                        !
        RUNTOT.TYPE$, @(30);_                                        !
        RUNTOT.AMOUNT.DR,@(40),"(####,###,##0.00000)";_              !
        RUNTOT.AMOUNT.CR,@(60),"(####,###,##0.00000)";_              !
        RUNTOT.KEY.1$,@(80);_                                        !
        RUNTOT.KEY.2$,@(90);_                                        !
        RUNTOT.KEY.3$,@(100);_                                       !
        (CR);_                                                       !
        RUNTOT.COUNT.DR, @(44),"(####,##0)";_                        !
        RUNTOT.COUNT.CR, @(64),"(####,##0)";_                        !
        RUNTOT.DESC$,@(80)                                           !
   SET RUNTOT.COUNT.ONLY.FMT.LINES=1                                 !
RUNTOT.DETAIL.COUNT.ONLY.FMT: FORMAT _                               !
        RUNTOT.KEY.4$,@(00);_                                        !
        RUNTOT.KEY.5$,@(10);_                                        !
        RUNTOT.KEY.6$,@(20);_                                        !
        RUNTOT.TYPE$, @(30);_                                        !
        RUNTOT.COUNT.DR, @(34),"(####,##0)";_                        !
        RUNTOT.COUNT.CR, @(44),"(####,##0)";_                        !
        RUNTOT.DESC$,@(60)                                           !
   SET RUNTOT.AMOUNT.ONLY.FMT.LINES=1                                !
RUNTOT.DETAIL.AMOUNT.ONLY.FMT: FORMAT _                              !
        RUNTOT.KEY.4$,@(00);_                                        !
        RUNTOT.KEY.5$,@(10);_                                        !
        RUNTOT.KEY.6$,@(20);_                                        !
        RUNTOT.TYPE$, @(30);_                                        !
        RUNTOT.AMOUNT.DR,@(34),"(####,###,##0.00000)";_              !
        RUNTOT.AMOUNT.CR,@(54),"(####,###,##0.00000)";_              !
        RUNTOT.DESC$,@(80)                                           !
!--------------------------------------------------------------------!

.endif
.if EXEPASS
!
!   RUNTOT Processing - PROCESSING
!
!   requires:   ^RUNTOT     RUNTOT file definition
!                RUNTOT     LUN (Logical Unit Number) must be SET
!                           OUTPUT.PROGRAM.SPECIFIC.RUNTOT
!                PROGRAM.ID$
!
!====================================================================!
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!
!====================
DETERMINE.RUNTOT.LEN:
!====================
    RTN$="DETERMINE.RUNTOT.LEN"
!----------------------------------------------------------
    CURRENT.LEN.RUNTOT.KEY.1    =   LEN(STRIP(RUNTOT.KEY.1$))
    CURRENT.LEN.RUNTOT.KEY.2    =   LEN(STRIP(RUNTOT.KEY.2$))
    CURRENT.LEN.RUNTOT.KEY.3    =   LEN(STRIP(RUNTOT.KEY.3$))
    CURRENT.LEN.RUNTOT.KEY.4    =   LEN(STRIP(RUNTOT.KEY.4$))
    CURRENT.LEN.RUNTOT.KEY.5    =   LEN(STRIP(RUNTOT.KEY.5$))
    CURRENT.LEN.RUNTOT.KEY.6    =   LEN(STRIP(RUNTOT.KEY.6$))
    CURRENT.LEN.RUNTOT.DESC     =   LEN(STRIP(RUNTOT.DESC$))
!----------------------------------------------------------
!   Check RUNTOT.AMOUNT.DR
    CURRENT.RUNTOT.AMOUNT.DR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.AMOUNT.DR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.AMOUNT.DR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.AMOUNT.DR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.AMOUNT.DR EQ 0 THEN
            CURRENT.RUNTOT.AMOUNT.DR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
!   Check RUNTOT.AMOUNT.CR
    CURRENT.RUNTOT.AMOUNT.CR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.AMOUNT.CR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.AMOUNT.CR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.AMOUNT.CR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.AMOUNT.CR EQ 0 THEN
            CURRENT.RUNTOT.AMOUNT.CR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
!   Check RUNTOT.COUNT.DR
    CURRENT.RUNTOT.COUNT.DR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.COUNT.DR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.COUNT.DR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.COUNT.DR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.COUNT.DR EQ 0 THEN
            CURRENT.RUNTOT.COUNT.DR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
!   Check RUNTOT.COUNT.CR
    CURRENT.RUNTOT.COUNT.CR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.COUNT.CR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.COUNT.CR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.COUNT.CR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.COUNT.CR EQ 0 THEN
            CURRENT.RUNTOT.COUNT.CR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
    RETURN
!=====================
DETERMINE.RUNTOT.ZERO:
!=====================
    RTN$="DETERMINE.RUNTOT.EMPTY"
!
    CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = Y.ANS$
    IF CURRENT.RUNTOT.AMOUNT.DR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
    IF CURRENT.RUNTOT.AMOUNT.CR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
!
    CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = Y.ANS$
    IF CURRENT.RUNTOT.COUNT.DR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
    IF CURRENT.RUNTOT.COUNT.CR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
!
    CURRENT.RUNTOT.RECORD.IS.ZERO$ = Y.ANS$
    IF CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = N.ANS$ THEN
    	 CURRENT.RUNTOT.RECORD.IS.ZERO$ = N.ANS$
    ENDIF
    IF CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.RECORD.IS.ZERO$ = N.ANS$
    ENDIF
!
    RETURN
!======================
INITIALISE.R.E.P.O.R.T:
!======================
    RUNTOT.HEADER.TEXT$ = R.E.P.O.R.T$
    RUNTOT.HEADER.TEXT$ = PAD(RUNTOT.HEADER.TEXT$)
    RETURN

!============================
INITIALISE.RUN.TOTALS.REPORT:
!============================
    RUNTOT.HEADER.TEXT$ = RUN.TOTALS.REPORT$
    RUNTOT.HEADER.TEXT$ = PAD(RUNTOT.HEADER.TEXT$)
    RETURN
!=================
INITIALISE.RUNTOT:
!=================
    RTN$="INITIALISE.RUNTOT"
    RUNTOT.KEY.1$       = PROGRAM.ID$
    RUNTOT.KEY.2$       = RUNTOT.DATE.CCYYMMDD$
    RUNTOT.KEY.3$       = RUNTOT.TIME.ISO$
    RUNTOT.KEY.4$       = STRING(" ",LEN.RUNTOT.KEY.4)
    RUNTOT.KEY.5$       = STRING(" ",LEN.RUNTOT.KEY.5)
    RUNTOT.KEY.6$       = STRING(" ",LEN.RUNTOT.KEY.6)
    RUNTOT.TYPE$        = STRING(" ",LEN.RUNTOT.TYPE)
    RUNTOT.DESC$        = STRING(" ",LEN.RUNTOT.DESC)
    RUNTOT.KEY.1$       = PAD(RUNTOT.KEY.1$)
    RUNTOT.KEY.2$       = PAD(RUNTOT.KEY.2$)
    RUNTOT.KEY.3$       = PAD(RUNTOT.KEY.3$)
    RUNTOT.KEY.4$       = PAD(RUNTOT.KEY.4$)
    RUNTOT.KEY.5$       = PAD(RUNTOT.KEY.5$)
    RUNTOT.KEY.6$       = PAD(RUNTOT.KEY.6$)
    RUNTOT.TYPE$        = PAD(RUNTOT.TYPE$)
    RUNTOT.DESC$        = PAD(RUNTOT.DESC$)
    RUNTOT.AMOUNT.DR    = 0
    RUNTOT.AMOUNT.CR    = 0
    RUNTOT.COUNT.DR     = 0
    RUNTOT.COUNT.CR     = 0
    RETURN
!==================================
INITIALISE.RUNTOT.HEADER.DATE.TIME:
!==================================
    RUNTOT.DATE.TIME.SERIAL = DATE2NUM(DATE$,0)
    RUNTOT.DATE.TIME.LOCAL$ = NUM2DATE(RUNTOT.DATE.TIME.SERIAL, _
                                       RUNTOT.DATE.TIME.OPT.LOCAL)
    RUNTOT.DATE.TIME$       = SUB(RUNTOT.DATE.TIME.LOCAL$,1, _
                                  RUNTOT.DATE.TIME.LEN)
    RETURN
!=============================
INITIALISE.RUNTOT.HEADER.TEXT:
!=============================
    RUNTOT.HEADER.TEXT$ = ""
    RUNTOT.HEADER.TEXT$ = PAD(RUNTOT.HEADER.TEXT$)
    RETURN

!=============
OUTPUT.RUNTOT:
!=============
    RTN$="OUTPUT.RUNTOT"
!   Prepare the Date/Time which form Key.2 and Key.3
    GOSUB POPULATE.RUNTOT.DATE
    GOSUB POPULATE.RUNTOT.TIME
!
    GOSUB INITIALISE.RUNTOT
    RTN$="OUTPUT.RUNTOT"
    IF PRINT.RUNTOT.LINES.TO.SPOOL$ EQ Y.ANS$ THEN
!   Since Lines count down, subtract 1 to force printing
        RUNTOT.LINE = FORCE.RUNTOT.HEADER.PRINT - 1
    ENDIF
!   Individual subroutine calls are back in the source code
    GOSUB OUTPUT.PROGRAM.SPECIFIC.RUNTOT
!
    RETURN
!====================
POPULATE.RUNTOT.DATE:
!====================
    RTN$="POPULATE.RUNTOT.DATE"
    RUNTOT.DATE$            = DATE$
    RUNTOT.SERIAL.DATE      = DATE2NUM(RUNTOT.DATE$,0)
    RUNTOT.DATE.CCYYMMDD$   = NUM2DATE(RUNTOT.SERIAL.DATE,2)
    RETURN
!=====================
POPULATE.RUNTOT.KEY.4:
!=====================
    RTN$="POPULATE.RUNTOT.KEY.4:"
    CURRENT.LEN.RUNTOT.KEY.1.3  =   CURRENT.LEN.RUNTOT.KEY.1 + _
                                    CURRENT.LEN.RUNTOT.KEY.2 + _
                                    CURRENT.LEN.RUNTOT.KEY.3
    CURRENT.LEN.RUNTOT.KEY.4.6  =   CURRENT.LEN.RUNTOT.KEY.4 + _
                                    CURRENT.LEN.RUNTOT.KEY.5 + _
                                    CURRENT.LEN.RUNTOT.KEY.6
!   If none of the keys is being used, do nothing
!   if KEY.4$ is empty, even if following keys are used,
!       use the order written as the 4th Key
!       this will ensure that the sort order in the file
!       will match the order written
!
    IF  CURRENT.LEN.RUNTOT.KEY.4    EQ 0 AND _
        CURRENT.LEN.RUNTOT.KEY.4.6  GT 0 THEN
        RUNTOT.KEY.4$ = STRING(" ",6) + RUNTOT.TYPE$
    ENDIF
    RETURN
!====================
POPULATE.RUNTOT.TIME:
!====================
    RTN$="POPULATE.RUNTOT.TIME"
    RUNTOT.TIME.COMET$  = NUM2DATE(0,6)
    RUNTOT.TIME.ISO$    = SUB(RUNTOT.TIME.COMET$,1,8)
    RETURN
!=====================
PRINT.OR.WRITE.RUNTOT:
!=====================
    RTN$="PRINT.OR.WRITE.RUNTOT"
!   use the sequential count of RUNTOT records written as the type
    RUNTOT.WRITTEN      = RUNTOT.WRITTEN + 1
    RUNTOT.WRITTEN$     = STR(RUNTOT.WRITTEN)
    RUNTOT.TYPE$        = SUB(RUNTOT.WRITTEN$,2,2)
!
    RUNTOT.KEY.1$       = PAD(RUNTOT.KEY.1$)
    RUNTOT.KEY.2$       = PAD(RUNTOT.KEY.2$)
    RUNTOT.KEY.3$       = PAD(RUNTOT.KEY.3$)
    RUNTOT.KEY.4$       = PAD(RUNTOT.KEY.4$)
    RUNTOT.KEY.5$       = PAD(RUNTOT.KEY.5$)
    RUNTOT.KEY.6$       = PAD(RUNTOT.KEY.6$)
    RUNTOT.TYPE$        = PAD(RUNTOT.TYPE$)
    RUNTOT.DESC$        = PAD(RUNTOT.DESC$)
!
    GOSUB DETERMINE.RUNTOT.LEN
!
    GOSUB DETERMINE.RUNTOT.ZERO
!
    GOSUB PRINT.OR.WRITE.RUNTOT.DETAIL
!
    GOSUB INITIALISE.RUNTOT
!
    RETURN
!=============================
PRINT.RUNTOT.DETAILS.TO.SPOOL:
!=============================
    RTN$="PRINT.RUNTOT.DETAILS.TO.SPOOL"
    IF RUNTOT.LINE LT FORCE.RUNTOT.HEADER.PRINT THEN
        GOSUB PRINT.RUNTOT.HEADERS.TO.SPOOL
    ENDIF
    IF PRINT.RUNTOT.COUNTS.ONLY$ EQ Y.ANS$ THEN
        PRINT(LP,RUNTOT.DETAIL.COUNT.ONLY.FMT)
        RUNTOT.LINE = RUNTOT.LINE - RUNTOT.COUNT.ONLY.FMT.LINES
    ELSE
        IF PRINT.RUNTOT.AMOUNTS.ONLY$ EQ Y.ANS$ THEN
            PRINT(LP,RUNTOT.DETAIL.AMOUNT.ONLY.FMT)
            RUNTOT.LINE = RUNTOT.LINE - RUNTOT.AMOUNT.ONLY.FMT.LINES
        ELSE
            PRINT(LP,RUNTOT.DETAIL.FMT)
            RUNTOT.LINE = RUNTOT.LINE - RUNTOT.DETAIL.FMT.LINES
        ENDIF
    ENDIF
    NR.OF.RUNTOT.LINES = NR.OF.RUNTOT.LINES + 1
!
    RETURN
!==============================
PRINT.RUNTOT.HEADERS.TO.SPOOL:
!=============================
    RTN$="PRINT.RUNTOT.HEADERS.TO.SPOOL"
    RUNTOT.PAGE = RUNTOT.PAGE + 1
    NR.OF.RUNTOT.PAGES = RUNTOT.PAGE
    PRINT(LP,RUNTOT.HEADER.FMT)
    RUNTOT.LINE = LINES.PER.RUNTOT.PAGE
    RETURN
!============================
PRINT.OR.WRITE.RUNTOT.DETAIL:
!============================
    RTN$="PRINT.OR.WRITE.RUNTOT.DETAIL"
!
    IF PRINT.RUNTOT.LINES.TO.SPOOL$ EQ Y.ANS$ THEN
    	IF CURRENT.RUNTOT.RECORD.IS.ZERO$ EQ Y.ANS$ THEN
    		IF PRINT.ZERO.RUNTOT.LINES.TO.SPOOL$ EQ Y.ANS$ THEN
    			GOSUB PRINT.RUNTOT.DETAILS.TO.SPOOL
    		ENDIF
   		ELSE
   			GOSUB PRINT.RUNTOT.DETAILS.TO.SPOOL
   		ENDIF
    ENDIF
!
    IF WRITE.RUNTOT.RECORDS.TO.FILE$ EQ Y.ANS$ THEN
    	IF CURRENT.RUNTOT.RECORD.IS.ZERO$ EQ Y.ANS$ THEN
    		IF WRITE.ZERO.RUNTOT.RECORDS.TO.FILE$ EQ Y.ANS$ THEN
    			GOSUB WRITE.RUNTOT.DETAILS.TO.FILE
    		ENDIF
    	ELSE
    		GOSUB WRITE.RUNTOT.DETAILS.TO.FILE
    	ENDIF
    ENDIF
!
    RETURN
!============================
WRITE.RUNTOT.DETAILS.TO.FILE:
!============================
    GOSUB POPULATE.RUNTOT.KEY.4
    RTN$="WRITE.RUNTOT.DETAILS.TO.FILE"
    RUNTOT.KEY.1.6$ = RUNTOT.KEY.1$ + RUNTOT.KEY.2$ + _
                        RUNTOT.KEY.3$ + RUNTOT.KEY.4$ + _
                        RUNTOT.KEY.5$ + RUNTOT.KEY.6$
    RUNTOT.KEY$ = RUNTOT.KEY.1.6$ + RUNTOT.TYPE$
    INSERT (RUNTOT,RUNTOT.FMT) KEY=RUNTOT.KEY$,EXCPSUB=EXCPSUB.INSERT
    RETURN
!====================================================================
.endif