!
!=========================>  ^RUNTOTP  <=============================
!
!   RUNTOT Processing - PROCESSING
!
!   requires:   ^RUNTOT     RUNTOT file definition
!                RUNTOT     LUN (Logical Unit Number) must be SET
!                           OUTPUT.PROGRAM.SPECIFIC.RUNTOT
!                PROGRAM.ID$
!
!====================================================================!
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!
!====================
DETERMINE.RUNTOT.LEN:
!====================
    RTN$="DETERMINE.RUNTOT.LEN"
!----------------------------------------------------------
    CURRENT.LEN.RUNTOT.KEY.1    =   LEN(STRIP(RUNTOT.KEY.1$))
    CURRENT.LEN.RUNTOT.KEY.2    =   LEN(STRIP(RUNTOT.KEY.2$))
    CURRENT.LEN.RUNTOT.KEY.3    =   LEN(STRIP(RUNTOT.KEY.3$))
    CURRENT.LEN.RUNTOT.KEY.4    =   LEN(STRIP(RUNTOT.KEY.4$))
    CURRENT.LEN.RUNTOT.KEY.5    =   LEN(STRIP(RUNTOT.KEY.5$))
    CURRENT.LEN.RUNTOT.KEY.6    =   LEN(STRIP(RUNTOT.KEY.6$))
    CURRENT.LEN.RUNTOT.DESC     =   LEN(STRIP(RUNTOT.DESC$))
!----------------------------------------------------------
!   Check RUNTOT.AMOUNT.DR
    CURRENT.RUNTOT.AMOUNT.DR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.AMOUNT.DR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.AMOUNT.DR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.AMOUNT.DR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.AMOUNT.DR EQ 0 THEN
            CURRENT.RUNTOT.AMOUNT.DR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
!   Check RUNTOT.AMOUNT.CR
    CURRENT.RUNTOT.AMOUNT.CR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.AMOUNT.CR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.AMOUNT.CR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.AMOUNT.CR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.AMOUNT.CR EQ 0 THEN
            CURRENT.RUNTOT.AMOUNT.CR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
!   Check RUNTOT.COUNT.DR
    CURRENT.RUNTOT.COUNT.DR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.COUNT.DR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.COUNT.DR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.COUNT.DR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.COUNT.DR EQ 0 THEN
            CURRENT.RUNTOT.COUNT.DR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
!   Check RUNTOT.COUNT.CR
    CURRENT.RUNTOT.COUNT.CR.IS.SMALL$  = N.ANS$
    CURRENT.RUNTOT.COUNT.CR.IS.ZERO$   = N.ANS$
    IF ABS(RUNTOT.COUNT.CR) LE RUNTOT.AMOUNT.IS.SMALL THEN
        CURRENT.RUNTOT.COUNT.CR.IS.SMALL$ = Y.ANS$
        IF RUNTOT.COUNT.CR EQ 0 THEN
            CURRENT.RUNTOT.COUNT.CR.IS.ZERO$ = Y.ANS$
        ENDIF
    ENDIF
!----------------------------------------------------------
    RETURN
!=====================
DETERMINE.RUNTOT.ZERO:
!=====================
    RTN$="DETERMINE.RUNTOT.EMPTY"
!
    CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = Y.ANS$
    IF CURRENT.RUNTOT.AMOUNT.DR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
    IF CURRENT.RUNTOT.AMOUNT.CR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
!
    CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = Y.ANS$
    IF CURRENT.RUNTOT.COUNT.DR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
    IF CURRENT.RUNTOT.COUNT.CR.IS.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = N.ANS$
    ENDIF
!
    CURRENT.RUNTOT.RECORD.IS.ZERO$ = Y.ANS$
    IF CURRENT.RUNTOT.AMOUNTS.ARE.ZERO$ = N.ANS$ THEN
    	 CURRENT.RUNTOT.RECORD.IS.ZERO$ = N.ANS$
    ENDIF
    IF CURRENT.RUNTOT.COUNTS.ARE.ZERO$ = N.ANS$ THEN
    	CURRENT.RUNTOT.RECORD.IS.ZERO$ = N.ANS$
    ENDIF
!
    RETURN
!======================
INITIALISE.R.E.P.O.R.T:
!======================
    RUNTOT.HEADER.TEXT$ = R.E.P.O.R.T$
    RUNTOT.HEADER.TEXT$ = PAD(RUNTOT.HEADER.TEXT$)
    RETURN

!============================
INITIALISE.RUN.TOTALS.REPORT:
!============================
    RUNTOT.HEADER.TEXT$ = RUN.TOTALS.REPORT$
    RUNTOT.HEADER.TEXT$ = PAD(RUNTOT.HEADER.TEXT$)
    RETURN
!=================
INITIALISE.RUNTOT:
!=================
    RTN$="INITIALISE.RUNTOT"
    RUNTOT.KEY.1$       = PROGRAM.ID$
    RUNTOT.KEY.2$       = RUNTOT.DATE.CCYYMMDD$
    RUNTOT.KEY.3$       = RUNTOT.TIME.ISO$
    RUNTOT.KEY.4$       = STRING(" ",LEN.RUNTOT.KEY.4)
    RUNTOT.KEY.5$       = STRING(" ",LEN.RUNTOT.KEY.5)
    RUNTOT.KEY.6$       = STRING(" ",LEN.RUNTOT.KEY.6)
    RUNTOT.TYPE$        = STRING(" ",LEN.RUNTOT.TYPE)
    RUNTOT.DESC$        = STRING(" ",LEN.RUNTOT.DESC)
    RUNTOT.KEY.1$       = PAD(RUNTOT.KEY.1$)
    RUNTOT.KEY.2$       = PAD(RUNTOT.KEY.2$)
    RUNTOT.KEY.3$       = PAD(RUNTOT.KEY.3$)
    RUNTOT.KEY.4$       = PAD(RUNTOT.KEY.4$)
    RUNTOT.KEY.5$       = PAD(RUNTOT.KEY.5$)
    RUNTOT.KEY.6$       = PAD(RUNTOT.KEY.6$)
    RUNTOT.TYPE$        = PAD(RUNTOT.TYPE$)
    RUNTOT.DESC$        = PAD(RUNTOT.DESC$)
    RUNTOT.AMOUNT.DR    = 0
    RUNTOT.AMOUNT.CR    = 0
    RUNTOT.COUNT.DR     = 0
    RUNTOT.COUNT.CR     = 0
    RETURN
!==================================
INITIALISE.RUNTOT.HEADER.DATE.TIME:
!==================================
    RUNTOT.DATE.TIME.SERIAL = DATE2NUM(DATE$,0)
    RUNTOT.DATE.TIME.LOCAL$ = NUM2DATE(RUNTOT.DATE.TIME.SERIAL, _
                                       RUNTOT.DATE.TIME.OPT.LOCAL)
    RUNTOT.DATE.TIME$       = SUB(RUNTOT.DATE.TIME.LOCAL$,1, _
                                  RUNTOT.DATE.TIME.LEN)
    RETURN
!=============================
INITIALISE.RUNTOT.HEADER.TEXT:
!=============================
    RUNTOT.HEADER.TEXT$ = ""
    RUNTOT.HEADER.TEXT$ = PAD(RUNTOT.HEADER.TEXT$)
    RETURN

!=============
OUTPUT.RUNTOT:
!=============
    RTN$="OUTPUT.RUNTOT"
!   Prepare the Date/Time which form Key.2 and Key.3
    GOSUB POPULATE.RUNTOT.DATE
    GOSUB POPULATE.RUNTOT.TIME
!
    GOSUB INITIALISE.RUNTOT
    RTN$="OUTPUT.RUNTOT"
    IF PRINT.RUNTOT.LINES.TO.SPOOL$ EQ Y.ANS$ THEN
!   Since Lines count down, subtract 1 to force printing
        RUNTOT.LINE = FORCE.RUNTOT.HEADER.PRINT - 1
    ENDIF
!   Individual subroutine calls are back in the source code
    GOSUB OUTPUT.PROGRAM.SPECIFIC.RUNTOT
!
    RETURN
!====================
POPULATE.RUNTOT.DATE:
!====================
    RTN$="POPULATE.RUNTOT.DATE"
    RUNTOT.DATE$            = DATE$
    RUNTOT.SERIAL.DATE      = DATE2NUM(RUNTOT.DATE$,0)
    RUNTOT.DATE.CCYYMMDD$   = NUM2DATE(RUNTOT.SERIAL.DATE,2)
    RETURN
!=====================
POPULATE.RUNTOT.KEY.4:
!=====================
    RTN$="POPULATE.RUNTOT.KEY.4:"
    CURRENT.LEN.RUNTOT.KEY.1.3  =   CURRENT.LEN.RUNTOT.KEY.1 + _
                                    CURRENT.LEN.RUNTOT.KEY.2 + _
                                    CURRENT.LEN.RUNTOT.KEY.3
    CURRENT.LEN.RUNTOT.KEY.4.6  =   CURRENT.LEN.RUNTOT.KEY.4 + _
                                    CURRENT.LEN.RUNTOT.KEY.5 + _
                                    CURRENT.LEN.RUNTOT.KEY.6
!   If none of the keys is being used, do nothing
!   if KEY.4$ is empty, even if following keys are used,
!       use the order written as the 4th Key
!       this will ensure that the sort order in the file
!       will match the order written
!
    IF  CURRENT.LEN.RUNTOT.KEY.4    EQ 0 AND _
        CURRENT.LEN.RUNTOT.KEY.4.6  GT 0 THEN
        RUNTOT.KEY.4$ = STRING(" ",6) + RUNTOT.TYPE$
    ENDIF
    RETURN
!====================
POPULATE.RUNTOT.TIME:
!====================
    RTN$="POPULATE.RUNTOT.TIME"
    RUNTOT.TIME.COMET$  = NUM2DATE(0,6)
    RUNTOT.TIME.ISO$    = SUB(RUNTOT.TIME.COMET$,1,8)
    RETURN
!=====================
PRINT.OR.WRITE.RUNTOT:
!=====================
    RTN$="PRINT.OR.WRITE.RUNTOT"
!   use the sequential count of RUNTOT records written as the type
    RUNTOT.WRITTEN      = RUNTOT.WRITTEN + 1
    RUNTOT.WRITTEN$     = STR(RUNTOT.WRITTEN)
    RUNTOT.TYPE$        = SUB(RUNTOT.WRITTEN$,2,2)
!
    RUNTOT.KEY.1$       = PAD(RUNTOT.KEY.1$)
    RUNTOT.KEY.2$       = PAD(RUNTOT.KEY.2$)
    RUNTOT.KEY.3$       = PAD(RUNTOT.KEY.3$)
    RUNTOT.KEY.4$       = PAD(RUNTOT.KEY.4$)
    RUNTOT.KEY.5$       = PAD(RUNTOT.KEY.5$)
    RUNTOT.KEY.6$       = PAD(RUNTOT.KEY.6$)
    RUNTOT.TYPE$        = PAD(RUNTOT.TYPE$)
    RUNTOT.DESC$        = PAD(RUNTOT.DESC$)
!
    GOSUB DETERMINE.RUNTOT.LEN
!
    GOSUB DETERMINE.RUNTOT.ZERO
!
    GOSUB PRINT.OR.WRITE.RUNTOT.DETAIL
!
    GOSUB INITIALISE.RUNTOT
!
    RETURN
!=============================
PRINT.RUNTOT.DETAILS.TO.SPOOL:
!=============================
    RTN$="PRINT.RUNTOT.DETAILS.TO.SPOOL"
    IF RUNTOT.LINE LT FORCE.RUNTOT.HEADER.PRINT THEN
        GOSUB PRINT.RUNTOT.HEADERS.TO.SPOOL
    ENDIF
    IF PRINT.RUNTOT.COUNTS.ONLY$ EQ Y.ANS$ THEN
        PRINT(LP,RUNTOT.DETAIL.COUNT.ONLY.FMT)
        RUNTOT.LINE = RUNTOT.LINE - RUNTOT.COUNT.ONLY.FMT.LINES
    ELSE
        IF PRINT.RUNTOT.AMOUNTS.ONLY$ EQ Y.ANS$ THEN
            PRINT(LP,RUNTOT.DETAIL.AMOUNT.ONLY.FMT)
            RUNTOT.LINE = RUNTOT.LINE - RUNTOT.AMOUNT.ONLY.FMT.LINES
        ELSE
            PRINT(LP,RUNTOT.DETAIL.FMT)
            RUNTOT.LINE = RUNTOT.LINE - RUNTOT.DETAIL.FMT.LINES
        ENDIF
    ENDIF
    NR.OF.RUNTOT.LINES = NR.OF.RUNTOT.LINES + 1
!
    RETURN
!==============================
PRINT.RUNTOT.HEADERS.TO.SPOOL:
!=============================
    RTN$="PRINT.RUNTOT.HEADERS.TO.SPOOL"
    RUNTOT.PAGE = RUNTOT.PAGE + 1
    NR.OF.RUNTOT.PAGES = RUNTOT.PAGE
    PRINT(LP,RUNTOT.HEADER.FMT)
    RUNTOT.LINE = LINES.PER.RUNTOT.PAGE
    RETURN
!============================
PRINT.OR.WRITE.RUNTOT.DETAIL:
!============================
    RTN$="PRINT.OR.WRITE.RUNTOT.DETAIL"
!
    IF PRINT.RUNTOT.LINES.TO.SPOOL$ EQ Y.ANS$ THEN
    	IF CURRENT.RUNTOT.RECORD.IS.ZERO$ EQ Y.ANS$ THEN
    		IF PRINT.ZERO.RUNTOT.LINES.TO.SPOOL$ EQ Y.ANS$ THEN
    			GOSUB PRINT.RUNTOT.DETAILS.TO.SPOOL
    		ENDIF
   		ELSE
   			GOSUB PRINT.RUNTOT.DETAILS.TO.SPOOL
   		ENDIF
    ENDIF
!
    IF WRITE.RUNTOT.RECORDS.TO.FILE$ EQ Y.ANS$ THEN
    	IF CURRENT.RUNTOT.RECORD.IS.ZERO$ EQ Y.ANS$ THEN
    		IF WRITE.ZERO.RUNTOT.RECORDS.TO.FILE$ EQ Y.ANS$ THEN
    			GOSUB WRITE.RUNTOT.DETAILS.TO.FILE
    		ENDIF
    	ELSE
    		GOSUB WRITE.RUNTOT.DETAILS.TO.FILE
    	ENDIF
    ENDIF
!
    RETURN
!============================
WRITE.RUNTOT.DETAILS.TO.FILE:
!============================
    GOSUB POPULATE.RUNTOT.KEY.4
    RTN$="WRITE.RUNTOT.DETAILS.TO.FILE"
    RUNTOT.KEY.1.6$ = RUNTOT.KEY.1$ + RUNTOT.KEY.2$ + _
                        RUNTOT.KEY.3$ + RUNTOT.KEY.4$ + _
                        RUNTOT.KEY.5$ + RUNTOT.KEY.6$
    RUNTOT.KEY$ = RUNTOT.KEY.1.6$ + RUNTOT.TYPE$
    INSERT (RUNTOT,RUNTOT.FMT) KEY=RUNTOT.KEY$,EXCPSUB=EXCPSUB.INSERT
    RETURN
!====================================================================
