!====================================================================!
!=========================>  ^SETVALS <==============================!
!====================================================================!
!  The purpose of the values is to associate a text with each option !
!  in this way, it serves to document the program flow that follows  !
!  from the various operator entries                                 !
!                                                                    !
!  As new programs and options are instituted, the various options   !
!  should be added here for reference.                               !
!                                                                    !
!                                                                    !
!  Complete list is formed from ^SETOPTS, ^SETVALS, ^VALIDS, ^ASCII  !
!====================================================================!         !
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!         !
.ifdef EXCP.INC.NOT.LOADED
        SET CONSOLE=0
!
        SET ALL.ANS$="ALL"
        SET ALL.PAD.ANS$="ALL "
!
        SET END.ANS$="END"
        SET END.PAD.ANS$="END "
!
        SET N.ANS$="N"
        SET NO.ANS$="NO"		!stripped of trailing blanks
        SET NO.PAD.ANS$="NO "	!padded with blank
!
        SET OK.ANS$="OK"
        SET OK.PAD.ANS$="OK "
!
        SET Y.ANS$="Y"
        SET YES.ANS$="YES"
        SET YES.PAD.ANS$="YES"
.endif

        SET BACK.SLASH.DELIM$="\"
        SET CARET.DELIM$="^"
        SET COLON.DELIM$=":"
        SET COMMA.DELIM$=","
        SET DOLLAR.DELIM$="$"
        SET PIPE.DELIM$="|"
        SET PLUS.DELIM$="+"
        SET SEMI.COLON.DELIM$=";"
        SET SLASH.DELIM$="/"
        SET SPLAT.DELIM$="*"
        SET TILDE.DELIM$="~"
!
        SET AMPERSAND.SIGN$="&"
        SET AND.SIGN$="&"
        SET AT.SIGN$="@40@"
        SET BACK.SLASH.SIGN$="\"
        SET BANG.SIGN$="@21@"
        SET CARET.SIGN$="^"
        SET COLON.SIGN$=":"
        SET COMMA.SIGN$=","
        SET DOLLAR.SIGN$="$"
        SET DOUBLE.QUOTE$="@22@"
        SET EQUALS.SIGN$="="
        SET EXCLAMATION.POINT$="@21@"
        SET HYPHEN.MINUS.SIGN$="-"
        SET MINUS.SIGN$="-"
        SET NBR.SIGN$="#"
        SET PCT.SIGN$="%"
        SET PIPE.SIGN$="|"
        SET PLUS.SIGN$="+"
        SET QUESTION.MARK$="?"
        SET SEMI.COLON.SIGN$=";"
        SET SHARP.SIGN$="#"
        SET SLASH.SIGN$="/"
        SET SINGLE.QUOTE$="@27@"
        SET SPLAT.SIGN$="*"
        SET TILDE.SIGN$="~"
        SET UNDERSCORE.SIGN$="@5F@"
!
        SET HIGH.VALUE$="@FF@"
        SET LOW.VALUE$="@00@"
        SET NULL.VALUE$="@00@"
        SET SPACE$="@40@"
        SET NUM.ZERO$="@30@"
        SET NUM.NINE$="@39@"
!--------------------------------------------------------------------
! Systems based on ASCII or a compatible character set use either
!  LF (Line feed, '\n', 0x0A, 10 in decimal)
!  CR (Carriage return, '\r', 0x0D, 13 in decimal)
!  CR followed by LF (CR+LF, 0x0D 0x0A).
!  Some rare systems, such as QNX before version 4, used the ASCII
!  RS (record separator, 0x1E, 30 in decimal) character as the newline character.
! LF:     Multics
!         Unix and Unix-like systems (GNU/Linux, AIX, Xenix, Mac OS X, FreeBSD, etc.),
!         BeOS, Amiga, RISC OS, and others.
!         However, in tty 'raw mode'
!         CR+LF is used for output
!         CR is used for input.
! CR+LF:  DOS (MS-DOS, PC-DOS, etc.), OS/2, Microsoft Windows, Symbian OS, Palm OS
! CR:     Mac OS up to version 9 and OS-9
! RS:     QNX pre-POSIX implementation.
! EBCDIC systemsmainly IBM z/OS (OS/390) and i5/OS (OS/400) use
! NEL     (Next Line, 0x15, 13) as the newline character. !
!         SET EOL.CR$   =  "@0D@"
!         SET EOL.CRLF$ =  "@0D0A@"
!         SET EOL.LF$   =  "@0A@"
!         SET EOL.NEL$  =  "@15@"

!====================================================================!
