!                                                                    !
!=========================>  ^SNTYPP   <=============================!
!                                                                    !
!   Sony Type Processing - PROCESSING                                !
!                                                                    !
!   requires:   ^SNTYPD      SONY Type Processing - DATA             !
!   use with:   ^SNSCANP     SONY Scan Processing - PROCESSING       !
!                                                                    !
!====================================================================!
! Change Log                                                         !
!====================================================================!
! FML  Name                     Organisation                         !
! ===  ======================== ================================     !
! RDA  Robert D. Acker, Jr.     All Systems Satellite                !
!====================================================================!
!<<ID>> FML Date       Description                                   !
!  ==   === ========== ==============================================!
!<<AA>> RDA 07/15/2010 Change Sony Serialised Rule for Suffixes:     !
!                      FROM: not (Buydown or Bundle)                 !
!                        TO: Contained in list of Suffixes           !
!<<XX>> FML MM/DD/CCYY                                               !
!<<XX>> FML MM/DD/CCYY                                               !
!<<XX>> FML MM/DD/CCYY                                               !
!====================================================================!
!====================================================================!
!--  0---|--- 10---|--- 20---|--- 30---|--- 40---|--- 50---|--- 60---|--- 70---|
!23456789|123456789|123456789|123456789|123456789|123456789|123456789|123456789|
!====================================================================!
!===============
CHECK.SONY.ITEM:
!===============
    GOSUB RESET.SONY.ITEM.FLAGS
    GOSUB CHECK.IF.SONY.ITEM
    IF IS.A.SONY.ITEM$ EQ Y.ANS$ THEN
        SONY.ITEM.LENGTH     = LEN(STRIP(SONY.INBR$))
!<<AA>> SONY.ITEM.SUFFIX$    = SUB(SONY.INBR$,SONY.ITEM.LENGTH,1)
        SONY.ITEM.SUFFIX$    = RSUB(STRIP(SONY.INBR$),1,1)     !<<AA>>
        SELECT SONY.ITEM.SUFFIX$
            CASE SONY.ITEM.SUFFIX.BUNDLE$
                IS.A.SONY.SERIAL.ITEM$  = N.ANS$
                IS.A.SONY.BUNDLE.ITEM$  = SONY.ITEM.SUFFIX.BUNDLE$
            CASE SONY.ITEM.SUFFIX.BUYDOWN$
                IS.A.SONY.SERIAL.ITEM$  = N.ANS$
                IS.A.SONY.BUYDOWN.ITEM$ = SONY.ITEM.SUFFIX.BUYDOWN$
            CASE ELSE
!<<AA>>====================================================
!<<AA>>         IS.A.SONY.SERIAL.ITEM$  = Y.ANS$
                IF SONY.ITEM.SERIAL.SUFFIXES$ CONTAINS _
                   SONY.ITEM.SUFFIX$ THEN
                    IS.A.SONY.SERIAL.ITEM$  = Y.ANS$
                    IF SONY.INBR$ CONTAINS _
                       SONY.ITEM.INDICATOR.BLUERAY$ THEN
                        IS.A.SONY.BLUERAY.ITEM$  =  Y.ANS$
                    ELSE
                        IS.A.SONY.TV.ITEM$       =  Y.ANS$
                    ENDIF
                ELSE
                    IS.A.SONY.SERIAL.ITEM$  = N.ANS$
                ENDIF
!<<AA>>====================================================
        ENDSELECT
    ENDIF
    RETURN
!==================
CHECK.IF.SONY.ITEM:
!==================
    IS.A.SONY.ITEM$          =  N.ANS$
    IF SUB(SONY.INBR$,1,2) EQ SONY.PREFIX$ THEN
        IS.A.SONY.ITEM$      = Y.ANS$
    ENDIF
    RETURN
!========================
POPULATE.SONY.TEXTS:
!========================
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.NON.SONY         )	 =  _
						    SONY.ITEM.TEXT.NON.SONY$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.SONY             )	 =  _
						    SONY.ITEM.TEXT.SONY$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.SERIAL           )	 =  _
						    SONY.ITEM.TEXT.SERIAL$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.BLUERAY          )	 =  _
						    SONY.ITEM.TEXT.BLUERAY$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.TV               )	 =  _
						    SONY.ITEM.TEXT.TV$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.OTHER.SERIAL     )	 =  _
						    SONY.ITEM.TEXT.OTHER.SERIAL$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.NON.SERIAL       )	 =  _
						    SONY.ITEM.TEXT.NON.SERIAL$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.BUNDLE           )	 =  _
						    SONY.ITEM.TEXT.BUNDLE$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.BUYDOWN          )	 =  _
						    SONY.ITEM.TEXT.BUYDOWN$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.OTHER.NON.SERIAL )	 =  _
						    SONY.ITEM.TEXT.OTHER.NON.SERIAL$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.UNKNOWN.1        )	 =  _
						    SONY.ITEM.TEXT.UNKNOWN.1$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.UNKNOWN.2        )	 =  _
						    SONY.ITEM.TEXT.UNKNOWN.2$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.UNKNOWN.3        )	 =  _
						    SONY.ITEM.TEXT.UNKNOWN.3$
		SONY.TEXTS$(PTR.SONY.ITEM.TEXT.UNKNOWN          )	 =  _
						    SONY.ITEM.TEXT.UNKNOWN$

    RETURN
!======================
RESET.SONY.ITEM.COUNTS:
!======================
    FOR IX.SONY.COUNTS = 1 TO NR.OF.SONY.COUNTS.TEXTS
        SONY.COUNTS(IX.SONY.COUNTS) = 0
    NEXT IX.SONY.COUNTS

    RETURN
!=====================
RESET.SONY.ITEM.FLAGS:
!=====================
    IS.A.SONY.BLUERAY.ITEM$         	=  N.ANS$
    IS.A.SONY.BUNDLE.ITEM$          	=  " "
    IS.A.SONY.BUYDOWN.ITEM$         	=  " "
    IS.A.SONY.ITEM$                 	=  N.ANS$
    IS.A.SONY.OTHER.NON.SERIAL.ITEM$	=  N.ANS$
    IS.A.SONY.SERIAL.ITEM$          	=  N.ANS$
    IS.A.SONY.TV.ITEM$              	=  N.ANS$

    RETURN
!====================
RESET.SONY.TYPE.TEXT:
!====================
    SONY.TYPE.TEXT.1$   =  ""
    SONY.TYPE.TEXT.2$   =  ""
    SONY.TYPE.TEXT.3$   =  ""

    RETURN
!========================
RESET.SONY.TYPE.TEXT.PTR:
!========================
    SONY.TYPE.TEXT.PTR.1 = PTR.SONY.ITEM.TEXT.UNKNOWN.1
    SONY.TYPE.TEXT.PTR.2 = PTR.SONY.ITEM.TEXT.UNKNOWN.2
    SONY.TYPE.TEXT.PTR.3 = PTR.SONY.ITEM.TEXT.UNKNOWN.3

    RETURN

!==================
SET.SONY.TYPE.TEXT:
!==================
    GOSUB SET.SONY.TYPE.TEXT.PTR

    SONY.TYPE.TEXT.1$   = STRIP(SONY.TEXTS$(SONY.TYPE.TEXT.PTR.1))
    SONY.TYPE.TEXT.2$   = STRIP(SONY.TEXTS$(SONY.TYPE.TEXT.PTR.2))
    SONY.TYPE.TEXT.3$   = STRIP(SONY.TEXTS$(SONY.TYPE.TEXT.PTR.3))

    SONY.TYPE.TEXT.1$   = PAD(SONY.TYPE.TEXT.1$)
    SONY.TYPE.TEXT.2$   = PAD(SONY.TYPE.TEXT.2$)
    SONY.TYPE.TEXT.3$   = PAD(SONY.TYPE.TEXT.3$)

    RETURN
!============================
SET.SONY.TYPE.TEXT.AND.TALLY:
!============================
    GOSUB CHECK.SONY.ITEM
    GOSUB SET.SONY.TYPE.TEXT
    GOSUB TALLY.SONY.COUNT
    
    RETURN        
!======================
SET.SONY.TYPE.TEXT.PTR:
!======================
    GOSUB RESET.SONY.TYPE.TEXT.PTR

    SELECT CASE IS.A.SONY.ITEM$
        CASE N.ANS$
            SONY.TYPE.TEXT.PTR.1   =	PTR.SONY.ITEM.TEXT.NON.SONY
        CASE Y.ANS$
            SONY.TYPE.TEXT.PTR.1   =	PTR.SONY.ITEM.TEXT.SONY
            SELECT CASE IS.A.SONY.SERIAL.ITEM$
                CASE N.ANS$
                    SONY.TYPE.TEXT.PTR.2   =	PTR.SONY.ITEM.TEXT.NON.SERIAL
                    IF IS.A.SONY.BUNDLE.ITEM$ EQ SONY.ITEM.SUFFIX.BUNDLE$ THEN
                        SONY.TYPE.TEXT.PTR.3 =	PTR.SONY.ITEM.TEXT.BUNDLE
                    ELSE
                        IF IS.A.SONY.BUYDOWN.ITEM$ EQ SONY.ITEM.SUFFIX.BUYDOWN$ THEN
                            SONY.TYPE.TEXT.PTR.3 =	PTR.SONY.ITEM.TEXT.BUYDOWN
                        ELSE
                            SONY.TYPE.TEXT.PTR.3 =	PTR.SONY.ITEM.TEXT.OTHER.NON.SERIAL
                        ENDIF
                    ENDIF
                CASE Y.ANS$
                    SONY.TYPE.TEXT.PTR.2   =	PTR.SONY.ITEM.TEXT.SERIAL
                    IF IS.A.SONY.BLUERAY.ITEM$ EQ Y.ANS$ THEN
                        SONY.TYPE.TEXT.PTR.3 =	PTR.SONY.ITEM.TEXT.BLUERAY
                    ELSE
                        IF IS.A.SONY.TV.ITEM$ EQ Y.ANS$ THEN
                            SONY.TYPE.TEXT.PTR.3 =	PTR.SONY.ITEM.TEXT.TV
                        ELSE
                            SONY.TYPE.TEXT.PTR.3 =	PTR.SONY.ITEM.TEXT.OTHER.SERIAL
                        ENDIF
                    ENDIF
            ENDSELECT
    ENDSELECT

    RETURN
!================
TALLY.SONY.COUNT:
!================
    IF TALLY.ONLY.SONY.ITEMS$ EQ Y.ANS$ THEN
        IF IS.A.SONY.ITEM$ EQ N.ANS$ THEN RETURN
    ENDIF

    IX.SONY.TALLY.1 = SONY.TYPE.TEXT.PTR.1
    IX.SONY.TALLY.2 = SONY.TYPE.TEXT.PTR.2
    IX.SONY.TALLY.3 = SONY.TYPE.TEXT.PTR.3

    SONY.COUNTS(IX.SONY.TALLY.1) = SONY.COUNTS(IX.SONY.TALLY.1) + 1
    SONY.COUNTS(IX.SONY.TALLY.2) = SONY.COUNTS(IX.SONY.TALLY.2) + 1
    SONY.COUNTS(IX.SONY.TALLY.3) = SONY.COUNTS(IX.SONY.TALLY.3) + 1

    IF IX.SONY.TALLY.1 EQ  PTR.SONY.ITEM.TEXT.UNKNOWN.1 OR _
       IX.SONY.TALLY.2 EQ  PTR.SONY.ITEM.TEXT.UNKNOWN.2 OR _
       IX.SONY.TALLY.3 EQ  PTR.SONY.ITEM.TEXT.UNKNOWN.3 THEN
       SONY.COUNTS(PTR.SONY.ITEM.TEXT.UNKNOWN) = _
       SONY.COUNTS(PTR.SONY.ITEM.TEXT.UNKNOWN) + 1
    ENDIF

    RETURN    
!====================================================================
